# -*- coding: utf-8 -*- 
# @Time    : 03/21/2024 
# @Author  : nzooherd 
# @File    : start.py 
# @Software: Visual Studio Code

from logging import getLogger
from aspect.api import ApiAspect
from controller import BaseController, PornherdBot

from telethon.events import filters, NewMessage
from telethon.types import Message

from service.user_service import UserService
from template.manual import ManualTemplate

logger = getLogger()

class StartController(BaseController):
    """
    """

    def __init__(self, mybot: PornherdBot) -> None:
        super().__init__(mybot)
        self.user_service = UserService()

    @ApiAspect(filter=filters.Command('/start'))
    async def start(self, update: NewMessage) -> Message:
        """
        Say Hello to customer.
        """
        start_template = await self.user_service.new_user(update)
        return await self.mybot.bot_client.send_message(update.chat, template=start_template, link_preview=True)

    @ApiAspect(filter=filters.Command('/tips'))
    async def tips(self, update: NewMessage) -> Message:
        """
        Some tips
        """
        tip_template = await self.user_service.random_tip()
        return await self.mybot.bot_client.send_message(update.chat, template=tip_template)
    
    @ApiAspect(filter=filters.Command('/manual'))
    async def manual(self, update: NewMessage) -> Message:
        manual_template = ManualTemplate()
        return await self.mybot.bot_client.send_message(update.chat, template=manual_template, link_preview=True)

    @ApiAspect(filter=filters.Command('/referral'))
    async def referral(self, update: NewMessage) -> Message:
        """
        Return referral link
        """
        referral_template = await self.user_service.referral_link()
        return await self.mybot.bot_client.send_message(update.chat, template=referral_template)
